from py2duino import *
import time
from pylab import *

# fonction de conversion Mesure > Température
def conversion(Mesure):
    A=array([[ -1.81162256e+02],
       [  4.63167514e+00],
       [ -2.39294848e-02],
       [  6.04309226e-05],
       [ -8.20138026e-08],
       [  5.71859587e-11],
       [ -1.61153456e-14]])
    D=0
    for z in range (len(A)):
        D=D+A[z][0]*Mesure**z    #calcul de P
    return D

# Connexion à l'Arduino
MaCarte1 = Arduino(6) # Mettre uniquement le chiffre du COM de connexion
# Définir la broche de mesure de température (14)
Temperature = AnalogInput(MaCarte1,14)
# Définir la broche de commande du hacheur (8)
tension = AnalogOutput(MaCarte1,8)

# Mesure de la température et affichage
print(conversion(Temperature.read()))

# Commande de tension nulle
# LIGNE A UTILISER POUR ARRETER LE CHAUFFAGE
# EN CAS DE PROBLEME
tension.write(0)


# mesure BO (boucle ouverte)
# durée de la mesure : 2xTemps
# Créneau de commande où :
#     commande = U sur [0,Temps]  -> montée en température
#     commande = 0 sur [Temps,2xTemps]  -> descente en température
U=XXX         # tension de commande (entre 0 et 255)
Temps=800   # durée du créneau, en secondes (environ 8 minutes)
dt=1          # pas de temps en secondes

n=2*Temps/dt+1  # Nbre de pas pour un créneau
t=linspace(0,Temps*2,n)  # Initialisation du tableau de temps
Temp=zeros((t.shape[0])) # Initialisation du tableau de température
tinit=time.time()   # Mesure de l'horaire de début de mesure

for i in range(t.shape[0]):
    # Application de la commande en créneau
    if (t[i]<Temps): # si t appartient à [0,Temps]
        tension.write(U)  # On applique la commande U
    else:            # si t appartient à [Temps,2xTemps]
        tension.write(0)  # On applique la commande 0
    
    # Mesure de la température avec lissage sur nt points
    nm=0  # initialisation des variables
    Tm=0
    while(time.time()-tinit<(i+1)*dt): # pendant la durée du pas de temps
        Tm+=Temperature.read()  # faire la somme cumulée des mesures
        nm+=1                   # compter les mesures
        time.sleep(0.01)        # attendre 0.01s avant la prochaine mesure
    Tm=Tm/nm   # calculer la moyenne des mesures faites sur le pas de temps
    Temp[i]=conversion(Tm)   # Convertir la mesure (en inc) en température (en degrès)
    # Affichage de la température sur le pas de temps
    print("{} / {}  -- T= {} (sur {} valeurs)".format(i,n,Temp[i],nm))

# fermeture de la connexion avec la carte Arduino
MaCarte1.close()

plot(t,Temp)
show()
